// flactest.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FLAC/stream_encoder.h"

#define BUFFER_SIZE 1024

FILE *fout;

FLAC__StreamEncoderWriteStatus streamWriter(const FLAC__StreamEncoder *encoder, const FLAC__byte buffer[], unsigned bytes, unsigned samples, unsigned current_frame, void *client_data) {
	fwrite(buffer, 1, bytes, fout);
	return FLAC__STREAM_ENCODER_WRITE_STATUS_OK;
}

void metadataWriter(const FLAC__StreamEncoder *encoder, const FLAC__StreamMetadata *metadata, void *client_data) {
	return;
}

int WINAPI WinMain(HINSTANCE hInstance,
									 HINSTANCE hPrevInstance,
									 LPTSTR    lpCmdLine,
									 int       nCmdShow)
{
	FILE *fin;
	short in[BUFFER_SIZE];
	FLAC__int32 input[BUFFER_SIZE];
	FLAC__StreamEncoderState streamEncoderState;
	FLAC__StreamEncoder *streamEncoder;
	int i;
	
	SYSTEMTIME startTime;
	GetLocalTime(&startTime);
	
	int totalRead = 0;
	
	streamEncoder = FLAC__stream_encoder_new();
	
	fin = fopen("\\temp\\test_16k8.wav", "rb");
	fout = fopen("\\temp\\test_16k8.flac", "wb");
	
	if (!FLAC__stream_encoder_set_verify(streamEncoder, true)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_verify failed"), _T("error"), MB_OK);
		return false;
	}
	if (!FLAC__stream_encoder_set_channels(streamEncoder, 1)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_channels failed"), _T("error"), MB_OK);
		return -1;
	}
	if (!FLAC__stream_encoder_set_bits_per_sample(streamEncoder, 8)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_bits_per_sample failed"), _T("error"), MB_OK);
		return -1;
	}
	if (!FLAC__stream_encoder_set_sample_rate(streamEncoder, 16000)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_sample_rate failed"), _T("error"), MB_OK);
		return -1;
	}
	if (!FLAC__stream_encoder_set_write_callback(streamEncoder, streamWriter)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_write_callback failed"), _T("error"), MB_OK);
		return -1;
	}
	if (!FLAC__stream_encoder_set_metadata_callback(streamEncoder, metadataWriter)) {
		MessageBox(NULL, _T("FLAC__stream_encoder_set_metadata_callback failed"), _T("error"), MB_OK);
		return -1;
	}
	
	streamEncoderState = FLAC__stream_encoder_init(streamEncoder);
	if (streamEncoderState != FLAC__STREAM_ENCODER_OK) {
		TCHAR buffer[1024];
		_sntprintf(buffer, 1024, _T("FLAC__stream_encoder_init failed: %d"), streamEncoderState);
		MessageBox(NULL, buffer, _T("error"), MB_OK);
		return -1;
	}
	
	// skip the wav header
	fread(in, sizeof(short), 44, fin);
	
	while (1)	{
		if (fread(in, sizeof(short), BUFFER_SIZE, fin) != BUFFER_SIZE) {
			if (feof(fin))
				break;
			
			int err = ferror(fin);
			break;
		}
		
		totalRead += BUFFER_SIZE;
		
		//Copy the 16 bits values to float so Speex can work on them
		for (i=0;i<BUFFER_SIZE;i++)
			input[i]=in[i];
		
		if (!FLAC__stream_encoder_process_interleaved(streamEncoder, input, BUFFER_SIZE)) {
			FLAC__StreamEncoderState encoderState = FLAC__stream_encoder_get_state(streamEncoder);
			if (encoderState == FLAC__STREAM_ENCODER_VERIFY_DECODER_ERROR) {
				FLAC__StreamDecoderState decoderState = FLAC__stream_encoder_get_verify_decoder_state(streamEncoder);
				
				TCHAR buffer[1024];
				_sntprintf(buffer, 1024, _T("FLAC__stream_encoder_process_interleaved verify failed: %d"),decoderState);
				MessageBox(NULL, buffer, _T("error"), MB_OK);
			}
			else {
				TCHAR buffer[1024];
				_sntprintf(buffer, 1024, _T("FLAC__stream_encoder_process_interleaved failed: %d"), encoderState);
				MessageBox(NULL, buffer, _T("error"), MB_OK);
			}
			return -1;
		}
	}
	
	FLAC__stream_encoder_finish(streamEncoder);
	FLAC__stream_encoder_delete(streamEncoder);
	fclose(fout);
	fclose(fin);
	
	SYSTEMTIME endTime;
	GetLocalTime(&endTime);
	
	TCHAR buffer[1024];
	_sntprintf(buffer, 1024, _T("%04d/%02d/%02d %02d:%02d:%02d.%03d\n%04d/%02d/%02d %02d:%02d:%02d.%03d"), 
		startTime.wYear, startTime.wMonth, startTime.wDay, startTime.wHour, startTime.wMinute, startTime.wSecond, startTime.wMilliseconds,
		endTime.wYear, endTime.wMonth, endTime.wDay, endTime.wHour, endTime.wMinute, endTime.wSecond, endTime.wMilliseconds);
	MessageBox(NULL, buffer, _T("done"), MB_OK);
	
	return 0;
}

